<template>
  <div>
    <LoadingSpinner v-if="loading" />
    <div class="category-list" v-if="loaded">
      <CategoryListItem v-for="category in categories" :key="category.id" :category="category" />
    </div>
  </div>
</template>

<script>
import { ref, onMounted } from 'vue'
import { LoadingSpinner, useApi, useNotification } from '../../core'
import { useAuth } from '../../identity'
import CategoriesApi from '../api/categories-api.js'
import CategoryListItem from './category-list-item.vue'

export default {
  name: 'CategoryList',
  components: {
    LoadingSpinner,
    CategoryListItem,
  },
  setup() {
    const api = useApi()
    const auth = useAuth()
    const notify = useNotification()
    const categoriesApi = new CategoriesApi(api, auth)

    const loading = ref(false)
    const loaded = ref(false)
    const categories = ref([])

    const loadAsync = async () => {
      loading.value = true
      loaded.value = false

      try {
        const response = await categoriesApi.fetchAsync({ expand: 'all' })
        categories.value = response.data
        loaded.value = true
      } catch (ex) {
        notify.error('There was a problem getting the categories.', ex)
      } finally {
        loading.value = false
      }
    }

    onMounted(async () => {
      await loadAsync()
    })

    return {
      loading,
      loaded,
      categories,
    }
  },
}
</script>
